Rem
Rem $Header: umonmods.sql 25-nov-2003.10:47:05 arithikr Exp $
Rem
Rem umonmods.sql
Rem
Rem Copyright (c) 2003, Oracle Corporation.  All rights reserved.  
Rem
Rem    NAME
Rem      umonmods.sql - add drop_segments column to sys.mon_mods$.
Rem
Rem    DESCRIPTION
Rem      Introduce a new column drop_segments to the sys.mon_mods$
Rem      to keep track of the number of partition segments that were 
Rem      dropped or exchanged.
Rem
Rem    NOTES
Rem      * This script must be run using SQL*PLUS when install patchset
Rem        fix for this bug 3121812.
Rem      * You must be connected AS SYSDBA to run this script.
Rem      * You must run catalog.sql after this script to redefine
Rem        USE_, DBA_ and ALL_TABLE_MODIFICATIONS views.
Rem      * SMON and some other process may experience ORA-00904 like:
Rem        SMON: following errors trapped and ignored: 
Rem        ORA-00904: "DROP_SEGMENTS": invalid identifier 
Rem      * This error should go away after running this script.
Rem
Rem    MODIFIED   (MM/DD/YY)
Rem    arithikr    11/25/03 - Created for Bug 3121812
Rem

SET ECHO ON
SET FEEDBACK 1
SET NUMWIDTH 10
SET LINESIZE 80
SET TRIMSPOOL ON
SET TAB OFF
SET PAGESIZE 100

Rem ===========================================
Rem add drop_segments column to mon_mods$ table
Rem See comments in sql.bsq
Rem if the column is already existed, just ignore the ORA-01430
Rem ===========================================
alter table sys.mon_mods$ add
(
   drop_segments number default 0
)
/

